﻿using System.Windows.Input;
using MvvmFoundation.Wpf;

namespace ArchiCop.ViewModel
{
    public enum GraphCommandViewModelType
    {
        Graph,
        Datasource,
        VisualStudioDatasource
    }

    public class GraphCommandViewModel : ViewModelBase
    {
        public GraphCommandViewModel(string displayName, GraphCommandViewModelType viewModelType, string tag)
        {
            base.DisplayName = displayName;
            Tag = tag;

            ShowCommand = new RelayCommand(() =>
                {
                    App.Messenger.NotifyColleagues(App.CLEAR_WORKSPACES);
                    App.Messenger.NotifyColleagues(App.SET_WORKSPACES_DISPLAYTEXT, displayName);
                    ShowGraphCommand.Execute(null);
                    ShowEdgesCommand.Execute(null);
                    ShowVerticesCommand.Execute(null);
                });

            switch (viewModelType)
            {
                case GraphCommandViewModelType.Datasource:
                    ImageSource = "Avosoft-Warm-Toolbar-Database.ico";
                    break;
                case GraphCommandViewModelType.Graph:
                    ImageSource = "Icojam-Onebit-Diagram.ico";
                    break;
                case GraphCommandViewModelType.VisualStudioDatasource:
                    ImageSource = "Dakirby309-Windows-8-Metro-Apps-Visual-Studio-alt-Metro.ico";
                    break;
            }
        }

        public ICommand ShowGraphCommand { get; set; }
        public ICommand ShowEdgesCommand { get; set; }
        public ICommand ShowVerticesCommand { get; set; }

        public ICommand ShowCommand { get; private set; }

        public string Tag { get; private set; }

        public string ImageSource { get; private set; }
    }
}