﻿using System.Collections.Generic;
using System.Linq;
using ArchiCop.Core;
using NUnit.Framework;

namespace ArchiCop.VisualStudioData
{
    [TestFixture]
    public class VisualStudioProjectGraphTests : BaseTest
    {
        [Test]
        public void GraphHasCorrectNumberOfVertices()
        {
            //
            IEnumerable<VisualStudioProject> projects = GetSampleProjects();

            //
            ArchiCopGraph<VisualStudioProject> graph = projects.GetGraph();

            //
            Assert.IsTrue(graph.Vertices.Count() == 2);
        }

        [Test]
        public void GraphHasCorrectNumberOfEdges()
        {
            //
            IEnumerable<VisualStudioProject> projects = GetSampleProjects();

            //
            ArchiCopGraph<VisualStudioProject> graph = projects.GetGraph();

            //
            Assert.IsTrue(graph.Edges.Count() == 1);
        }
    }
}