﻿using System.Collections.Generic;
using System.Linq;
using ArchiCop.Core;

namespace ArchiCop.VisualStudioData
{
    public static class VisualStudioProjectGraphEngine
    {
        public static ArchiCopGraph<VisualStudioProject> GetGraph(this IEnumerable<ArchiCopEdge<VisualStudioProject>> edges)
        {
            var graph = new ArchiCopGraph<VisualStudioProject>();
            graph.AddVerticesAndEdgeRange(edges);
            return graph;
        }

        public static ArchiCopGraph<VisualStudioProject> GetGraph(this IEnumerable<VisualStudioProject> projects)
        {
            var graph = new ArchiCopGraph<VisualStudioProject>();
           
            foreach (VisualStudioProject visualStudioProject in projects)
            {
                foreach (VisualStudioProjectProjectReference visualStudioProjectProjectReference in visualStudioProject.ProjectReferences)
                {
                    VisualStudioProject target =
                        projects.First(item => item.ProjectGuid == visualStudioProjectProjectReference.Project);

                    graph.AddVerticesAndEdge(new ArchiCopEdge<VisualStudioProject>(visualStudioProject, target));
                }
            }

            return graph;
        }
    }
}